"use strict";
// import { ConfigFunction, CreateConfigItemOptions, } from '@babel/core';
Object.defineProperty(exports, "__esModule", { value: true });
exports.cjsBabelConfig = exports.esBabelConfig = exports.baseConfig = exports.presetEnvCjs = exports.presetEnvEs = exports.getPresetEnv = void 0;
const useESModules = true;
function getPresetEnv(options) {
    return [require.resolve('@babel/preset-env'), options];
}
exports.getPresetEnv = getPresetEnv;
exports.presetEnvEs = getPresetEnv({
    modules: false,
    // Exclude transforms that make all code slower; borrowed from https://github.com/facebook/create-react-app/blob/9123aae7a3beaba8b245f73eb0180baa7b2f8411/packages/babel-preset-react-app/create.js#L90
    exclude: ['transform-typeof-symbol'],
    targets: {
        esmodules: true,
    },
});
exports.presetEnvCjs = getPresetEnv({
    modules: 'commonjs',
});
exports.baseConfig = {
    presets: [
        [
            require.resolve('@babel/preset-react'),
            {
                development: process.env.NODE_ENV !== 'production',
            },
        ],
        [
            require.resolve('@babel/preset-typescript'),
            {
                isTSX: true,
                allExtensions: true,
                jsxPragma: 'React',
            },
        ],
    ],
    plugins: [
        // https://www.npmjs.com/package/babel-plugin-transform-async-to-promises
        require.resolve('babel-plugin-transform-async-to-promises'),
        require.resolve('@babel/plugin-syntax-dynamic-import'),
        require.resolve('@babel/plugin-proposal-object-rest-spread'),
        require.resolve('@babel/plugin-proposal-nullish-coalescing-operator'),
        [
            require.resolve('@babel/plugin-proposal-decorators'),
            {
                decoratorsBeforeExport: true,
            },
        ],
        require.resolve('@babel/plugin-proposal-class-properties'),
        require.resolve('@babel/plugin-proposal-optional-chaining'),
        require.resolve('@babel/plugin-transform-runtime'),
    ].filter(Boolean),
};
exports.esBabelConfig = {
    ...exports.baseConfig,
    presets: [...exports.baseConfig.presets, exports.presetEnvEs],
};
exports.cjsBabelConfig = {
    ...exports.baseConfig,
    presets: [...exports.baseConfig.presets, exports.presetEnvCjs],
};
//# sourceMappingURL=index.js.map